%define anolis_release 1

Name:           cryptsetup
Version:        2.4.3
Release:        %{anolis_release}%{?dist}
Summary:        Setup program for dm-crypt Based Encrypted Block Devices

License:        GPLv2+ and LGPLv2+
URL:            https://gitlab.com/cryptsetup/cryptsetup
Source0:        https://www.kernel.org/pub/linux/utils/cryptsetup/v2.4/%{name}-%{version}.tar.xz

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  gettext-devel
BuildRequires:  openssl-devel
BuildRequires:  popt-devel
BuildRequires:  device-mapper-devel
BuildRequires:  libuuid-devel
BuildRequires:  json-c-devel
BuildRequires:  libargon2-devel
BuildRequires:  libpwquality-devel
BuildRequires:  libblkid-devel
BuildRequires:  libssh-devel
Requires:       cryptsetup-libs = %{version}-%{release}
Requires:       libpwquality

%description
Cryptsetup is a utility used to conveniently set up disk encryption
based on the DMCrypt kernel module.

%package devel
Requires: cryptsetup-libs%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Summary: Headers and libraries for using encrypted file systems

%description devel
The cryptsetup-devel package contains libraries and header files
used for writing code that makes use of disk encryption.

%package libs
Summary: Cryptsetup shared library

%description libs
This package contains the cryptsetup shared library, libcryptsetup.

%package ssh-token
Summary: Cryptsetup LUKS2 SSH token
Requires: cryptsetup-libs = %{version}-%{release}

%description ssh-token
Experimental cryptsetup plugin for unlocking LUKS2 devices with token
connected to an SSH server.

%package -n veritysetup
Summary: A utility for setting up dm-verity volumes
Requires: cryptsetup-libs = %{version}-%{release}

%description -n veritysetup
The veritysetup package contains a utility for setting up
disk verification using dm-verity kernel module.

%package -n integritysetup
Summary: A utility for setting up dm-integrity volumes
Requires: cryptsetup-libs = %{version}-%{release}

%description -n integritysetup
The integritysetup package contains a utility for setting up
disk integrity protection using dm-integrity kernel module.

%package reencrypt
Summary: A utility for offline reencryption of LUKS encrypted disks
Requires: cryptsetup-libs = %{version}-%{release}

%description reencrypt
This package contains cryptsetup-reencrypt utility which
can be used for offline reencryption of disk in situ.

%prep
%autosetup -p 1

%build
autoreconf -i
%configure --enable-fips --enable-pwquality --enable-libargon2
%make_build

%install
%make_install
find %{buildroot}%{_libdir} -type f -name '*.la' -delete -print

%find_lang cryptsetup

%files
%license COPYING
%doc AUTHORS FAQ docs/*ReleaseNotes
%{_mandir}/man8/cryptsetup.8.gz
%{_sbindir}/cryptsetup

%files -n veritysetup
%license COPYING
%{_mandir}/man8/veritysetup.8.gz
%{_sbindir}/veritysetup

%files -n integritysetup
%license COPYING
%{_mandir}/man8/integritysetup.8.gz
%{_sbindir}/integritysetup

%files reencrypt
%license COPYING
%{_mandir}/man8/cryptsetup-reencrypt.8.gz
%{_sbindir}/cryptsetup-reencrypt

%files devel
%doc docs/examples/*
%{_includedir}/libcryptsetup.h
%{_libdir}/libcryptsetup.so
%{_libdir}/pkgconfig/libcryptsetup.pc

%files libs -f cryptsetup.lang
%license COPYING COPYING.LGPL
%{_libdir}/libcryptsetup.so.*
%dir %{_libdir}/%{name}/
%{_tmpfilesdir}/cryptsetup.conf
%ghost %attr(700, -, -) %dir /run/cryptsetup

%files ssh-token
%license COPYING COPYING.LGPL
%{_libdir}/%{name}/libcryptsetup-token-ssh.so
%{_mandir}/man8/cryptsetup-ssh.8.gz
%{_sbindir}/cryptsetup-ssh

%changelog
* Thu Mar 03 2022 Su Lifan <su-lifan@linux.alibaba.com> - 2.4.3-1
- Initial packaging for Anolis 23
